
include(FetchContent)

FetchContent_Declare(
	lua_repo
	GIT_REPOSITORY https://github.com/lua/lua.git
	GIT_TAG	       v5.3.5
	GIT_PROGRESS   TRUE
)

FetchContent_GetProperties(lua_repo)
if(NOT lua_repo_POPULATED)
  FetchContent_Populate(lua_repo)
endif()

message(STATUS "source: ${lua_repo_SOURCE_DIR}" )

file(GLOB lua_sources CONFIGURE DEPENDS ${lua_repo_SOURCE_DIR}/*.c)
set_source_files_properties(${lua_sources} PROPERTIES LANGUAGE CXX)
add_library(lua STATIC ${lua_sources})
target_include_directories(lua SYSTEM PUBLIC ${lua_repo_SOURCE_DIR})
target_compile_options(lua PRIVATE
	-std=c++17 -Og -g
	-Wno-aggressive-loop-optimizations
	-DLUAI_ASSERT
	-DLUA_USE_APICHECK
	)

set_target_properties( lua
    PROPERTIES CXX_CLANG_TIDY ""
)
