require "schpin_control.sequences.util"

-- Leg looks like (<link> - |<joint>|): 
--
-- body -|alfa|- coxa -(beta)- femur -(gama)- tibia
--
--

-- Names of all legs on the robot
legs = {"leg/fr", "leg/fl", "leg/rr", "leg/rl"}

-- Names of all alfa joints
alfas = {
    "leg/fr/alfa", "leg/fl/alfa", "leg/rr/alfa", "leg/rl/alfa"
}
-- Names of all beta joints
betas = {
    "leg/fr/beta", "leg/fl/beta", "leg/rr/beta", "leg/rl/beta"
}
-- Names of all gama joints
gamas = {
    "leg/fr/gama", "leg/fl/gama", "leg/rr/gama", "leg/rl/gama"
}

-- List of all joints on the robot
all = merge(alfas, merge(betas, gamas))

-- Directions in which the appropiate leg should unfold, indexes correlates with `legs`
dirs = {{1, -1, 0}, {1, 1, 0}, {-1, -1, 0}, {-1, 1, 0}}

-- Configuration of angles for each leg, when the robot is in neutral configuration
neutral_angles = {pi / 4, pi, pi}

