
#include <schpin_lib_exp/protocol/config.h>

#pragma once

namespace schpin
{
enum fw_config_enum : uint8_t
{
        BC_INPUT_BUFFER_TELEM_PERIOD_MS,
        BC_EVENT_BUFFER_TELEM_PERIOD_MS
};

struct fw_config
{
        clk_time input_buffer_telem_period_ms;
        clk_time event_buffer_telem_period_ms;

        auto bind_prot_config()
        {
                return std::make_tuple( prot_conf_parameter< BC_INPUT_BUFFER_TELEM_PERIOD_MS >(
                                            &input_buffer_telem_period_ms ),
                                        prot_conf_parameter< BC_EVENT_BUFFER_TELEM_PERIOD_MS >(
                                            &event_buffer_telem_period_ms ) );
        };
};

using fw_node_config_message = typename prot_config_types< fw_config >::config_master_message;
using fw_node_config_variant =
    typename prot_config_types< fw_config >::config_master_command_variant;
using node_fw_config_message = typename prot_config_types< fw_config >::master_config_message;
using node_fw_config_variant =
    typename prot_config_types< fw_config >::master_config_command_variant;

}  // namespace schpin
