#include "fw/dynamixel/context.h"
#include "shared/protocol.h"

#pragma once

namespace schpin
{

using dynmx_servo_events_variant = std::variant< float >;

class dynmx_servo
{
        dynmx_context context_;

      public:
        using receive_type   = dynmx_master_tuple;
        using events_variant = dynmx_servo_events_variant;

        dynmx_servo( dynmx_servo_id id )
          : context_( id )
        {
        }

        servo_id get_id() const
        {
                return *context_.get_id();
        }

        bool has_task() const
        {
                return false;
        }

        bool is_activating() const
        {
                return false;
        }

        template < typename Visitor >
        void stop( Visitor&& )
        {
        }

        std::optional< servo_master_message > on_servo_receive( clk_time,
                                                                s_ctl_id,
                                                                const dynmx_master_tuple& )
        {
                return {};
        }

        template < typename Visitor >
        void tick( clk_time, Visitor&& )
        {
        }

        template < typename Visitor >
        void on_event( ctl_id, clk_time, dynmx_servo_events_variant, Visitor&& )
        {
        }

        template < typename Visitor >
        void poll( clk_time, std::size_t, Visitor&& )
        {
        }

        em::either< dynmx_servo_events_variant, servo_master_message >
            on_servo_packet( ctl_id, master_servo_command_variant )
        {
                return { dynmx_servo_events_variant{ 0.f } };
        }
};
}  // namespace schpin
