#include "node/leg/model.h"

#pragma once

namespace schpin
{

struct leg_state
{
        dof_array< em::angle > angles;

        leg_state( const leg_model& model )
          : angles{ model.get_revolute_mapping().get_size_token() }
        {
        }

        bool update_joint_state( const leg_model& l, const std::string& jname, em::angle a )
        {
                for ( auto [i, j_ptr] : em::enumerate( l.get_revolute_mapping() ) ) {
                        if ( j_ptr->name == jname ) {
                                angles[i] = a;
                                return true;
                        }
                }
                return false;
        }
};

inline std::ostream& operator<<( std::ostream& os, const leg_state& state )
{
        return os << "leg angles: " << state.angles;
}

}  // namespace schpin
