#include "fw/dynamixel/protocol.h"

#include <gtest/gtest.h>
#include <schpin_lib/view.h>

using namespace schpin;

TEST( dynamixel_protocol, master_dynmx )
{
        std::array< uint8_t, 4 > buffer{ 0x00, 0x00, 0x02, 0x00 };

        master_dynmx_message msg = make_master_dynmx_msg< DYNMX_WRITE >(
            dynmx_servo_id::get< 1 >(), dynmx_addr{ 0x0074 }, dynmx_buffer{ buffer } );

        // TODO: fuuuuuuck clang format :/
        master_dynmx_message expected{ std::array< uint8_t, 16 >{ 0xFF,
                                                                  0xFF,
                                                                  0xFD,
                                                                  0x00,
                                                                  0x01,
                                                                  0x09,
                                                                  0x00,
                                                                  0x03,
                                                                  0x74,
                                                                  0x00,
                                                                  0x00,
                                                                  0x02,
                                                                  0x00,
                                                                  0x00,
                                                                  0xCA,
                                                                  0x89 } };

        EXPECT_EQ( msg, expected ) << std::hex << convert_view< int >( msg ) << "\n"
                                   << convert_view< int >( expected );
}

int main( int argc_in, char** argv_in )
{
        testing::InitGoogleTest( &argc_in, argv_in );

        return RUN_ALL_TESTS();
}
