#include <mutex>
#include <queue>
#include <readline/history.h>
#include <readline/readline.h>
#include <thread>

#pragma once

namespace schpin
{

class slua_repl
{
      public:
        slua_repl( const slua_repl& ) = delete;
        slua_repl( slua_repl&& )      = delete;
        slua_repl& operator=( const slua_repl& ) = delete;
        slua_repl& operator=( slua_repl&& ) = delete;

        slua_repl() = default;

        std::string prompt()
        {
                std::unique_ptr< char > opt_chars{ readline( ">" ) };
                if ( !opt_chars ) {
                        return "";
                }
                if ( strlen( opt_chars.get() ) > 0 ) {
                        add_history( opt_chars.get() );
                }
                return { opt_chars.get() };
        }
};

}  // namespace schpin
