
#include "schpin_lib/math.h"

#include <gtest/gtest.h>

using namespace schpin;

TEST( Determinant, fourtofour )
{

        std::array< float, 16 > data{1, 0, 2, -1, 3, 0, 0, 5, 2, 1, 4, -3, 1, 0, 5, 0};

        ASSERT_EQ( determinant< 4 >( data ), 30.f );
}

TEST( Determinant, threetothree )
{

        std::array< float, 9 > data{1, 2, 1, 3, 0, 4, 8, 4, 10};

        ASSERT_EQ( determinant< 3 >( data ), 0.f );
}

TEST( Determinant, twototwo )
{

        std::array< float, 4 > data{-6, 8, 0, 5};

        ASSERT_EQ( determinant< 2 >( data ), -30.f );
}
